[![Gitlab pipeline status](https://img.shields.io/gitlab/pipeline-status/marcelotsvaz%2Fpython-project-template?logo=gitlab&label=Build)](https://gitlab.com/marcelotsvaz/python-project-template/-/pipelines/latest)
[![Code coverage](https://img.shields.io/gitlab/pipeline-coverage/marcelotsvaz%2Fpython-project-template?branch=main&label=Coverage)](https://gitlab.com/marcelotsvaz/python-project-template/-/pipelines/latest)
[![GitLab release](https://img.shields.io/gitlab/v/release/marcelotsvaz%2Fpython-project-template?logo=gitlab&label=Release)](https://gitlab.com/marcelotsvaz/python-project-template/-/releases/permalink/latest)
[![PyPI package](https://img.shields.io/pypi/v/marcelotsvaz-python-project-template?logo=python&logoColor=%23CCCCCC&label=PyPI)](https://pypi.org/project/marcelotsvaz-python-project-template/)
[![Renovate](https://img.shields.io/badge/Renovate-enabled-green?logo=renovatebot&logoColor=%23007fa0)](https://gitlab.com/marcelotsvaz/python-project-template/-/issues/1)


# 🐍 Python Project Template
Template to quickly bootstrap Python projects.

Uses [PDM](https://pdm.fming.dev/) to manage dependencies, build distributions and publish to package repositories.


## ✨ Features
- Centralized configuration in `pyproject.toml`
- Dependency management with [PDM](https://pdm.fming.dev/)
- Testing with [unittest](https://docs.python.org/3/library/unittest.html)
- Linting with [Pylint](https://github.com/pylint-dev/pylint)
- Integration with [Visual Studio Code](https://code.visualstudio.com/)
- Building and publishing to [PyPI](https://pypi.org/)
- Documentation hosted on [GitLab Pages](https://docs.gitlab.com/ee/user/project/pages/)
- CI/CD with [GitLab](https://docs.gitlab.com/ee/ci/)
- Several useful examples
	- Type hints
	- Logging
	- CLI

For a detailed description of all features check the [documentation](https://marcelotsvaz.gitlab.io/python-project-template/documentation/).


## Contributing
TODO: Contributing.